package com.jsevy.jsvg;

import java.awt.Graphics2D;
import java.util.Vector;


/**
 * List of SVGStyles
 * @author jsevy
 *
 */
class SVGStyles
{
    private static int styleCount = 0;
    
    private Vector<SVGStyle> styles = new Vector<SVGStyle>();
    
    
    public SVGStyles()
    {
        styles = new Vector<SVGStyle>();
    }
    
    public synchronized static String getNextName()
    {
        styleCount++;
        return "style_" + styleCount;
    }
    
    
    public synchronized SVGGraphicsStyle getGraphicsStyle(Graphics2D graphics, boolean stroked, boolean filled)
    {
        SVGGraphicsStyle newStyle = new SVGGraphicsStyle(graphics, stroked, filled);
        
        int index = styles.indexOf(newStyle);
        
        if (index < 0)
        {
            // not found; add and return new style
            styles.add(newStyle);
            //this.addChild(newStyle);
            return newStyle;
        }
        else
        {
            // decrement style count, since incremented when created new style; 
            // not really needed, but why not - but really should synchronize
            styleCount--;
            return (SVGGraphicsStyle)styles.elementAt(index);
        }
    }
    
    
    public synchronized SVGTextStyle getTextStyle(Graphics2D graphics)
    {
        SVGTextStyle newStyle = new SVGTextStyle(graphics);
        
        int index = styles.indexOf(newStyle);
        
        if (index < 0)
        {
            // not found; add and return new style
            styles.add(newStyle);
            //addChild(newStyle);
            return newStyle;
        }
        else
        {
            // decrement style count, since incremented when created new style; 
            // not really needed, but why not - but really should synchronize
            styleCount--;
            return (SVGTextStyle)styles.elementAt(index);
        }
    }
    
    
}
