package com.jsevy.jxml;

import org.w3c.dom.DOMException;
import org.w3c.dom.Entity;
import org.w3c.dom.Node;

public class XMLEntity extends XMLNode implements Entity
{
    
    public String publicId = null;
    public String systemId = null;
    public String inputEncoding = null;
    public String xmlEncoding = null;
    public String xmlVersion = null;
    public String notationName = null;
    
    
    
    public XMLEntity(String name, String value)
    {
        super(name, value);
    }
    
    
    public XMLEntity(String name)
    {
        super(name);
    }
    
    
    public XMLEntity()
    {
        super();
    }
    
    
    @Override
    public short getNodeType()
    {
        // TODO Auto-generated method stub
        return Node.ENTITY_NODE;
    }
    
    
    
    /*
    @Override
    public Node cloneNode(boolean deep)
    {
        XMLEntity entity = new XMLEntity(this.getNodeName(), this.getNodeValue());
        
        entity.publicId = this.publicId;
        entity.systemId = this.systemId;
        entity.inputEncoding = this.inputEncoding;
        entity.xmlEncoding = this.xmlEncoding;
        entity.xmlVersion = this.xmlVersion;
        entity.notationName = this.notationName;
        
        return entity;
    }
    */
    
    
    
    @Override
    public String getTextContent() throws DOMException
    {
        // return depends on subclass, so overridden
        // for Entity node, return concatenation of the textContent attribute value of every child node,
        // excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes. This is the empty string if the 
        // node has no children.
        
        StringBuffer text = new StringBuffer();
        
        for (int i = 0; i < this.getChildNodes().getLength(); i++)
        {
            // recursively get text from nodes except comment nodes and processing instruction nodes
            Node child = this.getChildNodes().item(i);
            short nodeType = child.getNodeType();
            if ((nodeType != Node.COMMENT_NODE) && (nodeType != Node.PROCESSING_INSTRUCTION_NODE))
            {
                String childText = child.getTextContent();
                
                // filter out null results since StringBuffer appends the string "null"... :-\
                if (childText != null)
                    text.append(childText);
            }
        }
        
        return text.toString();
    }
    
    
    
    @Override
    public String getPublicId()
    {
        return this.publicId;
    }
    
    
    
    @Override
    public String getSystemId()
    {
        return this.systemId;
    }
    
    
    
    @Override
    public String getNotationName()
    {
        return this.notationName;
    }
    
    
    
    @Override
    public String getInputEncoding()
    {
        return this.inputEncoding;
    }
    
    
    
    @Override
    public String getXmlEncoding()
    {
        return this.xmlEncoding;
    }
    
    
    
    @Override
    public String getXmlVersion()
    {
        return this.xmlVersion;
    }
    
}
